<?php

/**
 * chat actions.
 *
 * @package    sam3
 * @subpackage chat
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class chatActions extends myActions {

    public function preExecute() {
        if ( ! in_array('chat', ModulPeer::getEnabled()))
        {
            $this->forwardSecure();
        }
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeIndex(sfWebRequest $request) {
        $this->forward('default', 'module');
    }

    public function executeConfig(sfWebRequest $request) {
        //sprawdzenie statusu servera chata

        /* Ustalenie portu servera. */
        $service_port = 9999;

        /* Pobranie adresu IP servera. */
        $address = gethostbyname('192.168.0.1');

        /* Create a TCP/IP socket. */
        $socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
        if ($socket === false) {
            //echo "socket_create() failed: reason: " . socket_strerror(socket_last_error()) . "\n";
        } else {
            //echo "OK.\n";
        }

        //echo "Attempting to connect to '$address' on port '$service_port'...";
        $this->result = socket_connect($socket, $address, $service_port);
        socket_close($socket);

        $this->form = new chatConfigFrom();

        if ($request->isMethod('post')) {
            $this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));
            if ($this->form->isValid()) {
                $values = $request->getParameter('chat_config');
                //print_r($values);
                foreach ($values as $key => $value) {
                    $ustawienie = UstawieniePeer::retrieveByPK($key, sfConfig::get('portal')->getId());
                    if (!$ustawienie) {
                        $conf = new Ustawienie();
                        $conf->setNazwa($key);
                        $conf->setTresc($value);
                        $conf->setPortalId(sfConfig::get('portal')->getId());
                        $conf->save();
                    } else {
                        $ustawienie->setTresc($value);
                        $ustawienie->save();
                    }
                    $this->getUser()->setFlash('notice', $this->__('save_ok'));
                    //echo $key.' = '.$value;
                }
            }
        }
    }

}
